# coding: utf-8

"""
    STACKIT Observability API

    API endpoints for Observability on STACKIT

    The version of the OpenAPI document: 1.1.1
    Contact: stackit-argus@mail.schwarz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501 docstring might be too long

from __future__ import annotations

import json
import pprint
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field
from typing_extensions import Self

from stackit.observability.models.inhibit_rules import InhibitRules
from stackit.observability.models.model_global import ModelGlobal
from stackit.observability.models.receivers import Receivers
from stackit.observability.models.route import Route


class Alert(BaseModel):
    """
    Alert
    """

    var_global: Optional[ModelGlobal] = Field(default=None, alias="global")
    inhibit_rules: Optional[List[InhibitRules]] = Field(default=None, alias="inhibitRules")
    receivers: List[Receivers]
    route: Route
    __properties: ClassVar[List[str]] = ["global", "inhibitRules", "receivers", "route"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of Alert from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # override the default output from pydantic by calling `to_dict()` of var_global
        if self.var_global:
            _dict["global"] = self.var_global.to_dict()
        # override the default output from pydantic by calling `to_dict()` of each item in inhibit_rules (list)
        _items = []
        if self.inhibit_rules:
            for _item in self.inhibit_rules:
                if _item:
                    _items.append(_item.to_dict())
            _dict["inhibitRules"] = _items
        # override the default output from pydantic by calling `to_dict()` of each item in receivers (list)
        _items = []
        if self.receivers:
            for _item in self.receivers:
                if _item:
                    _items.append(_item.to_dict())
            _dict["receivers"] = _items
        # override the default output from pydantic by calling `to_dict()` of route
        if self.route:
            _dict["route"] = self.route.to_dict()
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of Alert from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "global": ModelGlobal.from_dict(obj["global"]) if obj.get("global") is not None else None,
                "inhibitRules": (
                    [InhibitRules.from_dict(_item) for _item in obj["inhibitRules"]]
                    if obj.get("inhibitRules") is not None
                    else None
                ),
                "receivers": (
                    [Receivers.from_dict(_item) for _item in obj["receivers"]]
                    if obj.get("receivers") is not None
                    else None
                ),
                "route": Route.from_dict(obj["route"]) if obj.get("route") is not None else None,
            }
        )
        return _obj
