# coding: utf-8

"""
    STACKIT Observability API

    API endpoints for Observability on STACKIT

    The version of the OpenAPI document: 1.1.1
    Contact: stackit-argus@mail.schwarz
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501 docstring might be too long

from __future__ import annotations

import json
import pprint
from typing import Any, ClassVar, Dict, List, Optional, Set

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictStr
from typing_extensions import Self


class UpdateGrafanaConfigsPayloadGenericOauth(BaseModel):
    """
    UpdateGrafanaConfigsPayloadGenericOauth
    """

    api_url: StrictStr = Field(
        description="Set api_url to the resource that returns OpenID UserInfo compatible information.", alias="apiUrl"
    )
    auth_url: StrictStr = Field(description="Authentication endpoint of idp.", alias="authUrl")
    enabled: StrictBool = Field(description="enable or disable generic oauth login")
    name: Optional[StrictStr] = Field(default=None, description="Display name for the oAuth provider")
    oauth_client_id: StrictStr = Field(description="Oauth client id for auth endpoint.", alias="oauthClientId")
    oauth_client_secret: StrictStr = Field(
        description="Oauth client secret for auth endpoint.", alias="oauthClientSecret"
    )
    role_attribute_path: StrictStr = Field(
        description="Grafana checks for the presence of a role using the JMESPath specified via the role_attribute_path configuration option. The JMESPath is applied to the id_token first. If there is no match, then the UserInfo endpoint specified via the api_url configuration option is tried next. The result after evaluation of the role_attribute_path JMESPath expression should be a valid Grafana role, for example, Viewer, Editor or Admin For example: contains(roles[\\*], 'grafana-admin') && 'Admin' || contains(roles[\\*], 'grafana-editor') && 'Editor' || contains(roles[\\*], 'grafana-viewer') && 'Viewer'",
        alias="roleAttributePath",
    )
    role_attribute_strict: Optional[StrictBool] = Field(
        default=True,
        description="If  therole_attribute_path property does not return a role, then the user is assigned the Viewer role by default. You can disable the role assignment by setting role_attribute_strict = true. It denies user access if no role or an invalid role is returned.",
        alias="roleAttributeStrict",
    )
    scopes: Optional[StrictStr] = Field(
        default="openid profile email", description="Space seperated list of scopes of the token"
    )
    token_url: StrictStr = Field(description="Token endpoint of the idp.", alias="tokenUrl")
    use_pkce: Optional[StrictBool] = Field(
        default=None, description="enable or disable Proof Key for Code Exchange", alias="usePkce"
    )
    __properties: ClassVar[List[str]] = [
        "apiUrl",
        "authUrl",
        "enabled",
        "name",
        "oauthClientId",
        "oauthClientSecret",
        "roleAttributePath",
        "roleAttributeStrict",
        "scopes",
        "tokenUrl",
        "usePkce",
    ]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )

    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of UpdateGrafanaConfigsPayloadGenericOauth from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of UpdateGrafanaConfigsPayloadGenericOauth from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate(
            {
                "apiUrl": obj.get("apiUrl"),
                "authUrl": obj.get("authUrl"),
                "enabled": obj.get("enabled"),
                "name": obj.get("name"),
                "oauthClientId": obj.get("oauthClientId"),
                "oauthClientSecret": obj.get("oauthClientSecret"),
                "roleAttributePath": obj.get("roleAttributePath"),
                "roleAttributeStrict": (
                    obj.get("roleAttributeStrict") if obj.get("roleAttributeStrict") is not None else True
                ),
                "scopes": obj.get("scopes") if obj.get("scopes") is not None else "openid profile email",
                "tokenUrl": obj.get("tokenUrl"),
                "usePkce": obj.get("usePkce"),
            }
        )
        return _obj
